% This Matlab gui can be used to explore the use of normal vectors
% when modeling lighting of objects.
% Doug Johnson for UW CSE 457, Au 2003
% $Id: normalgui.m,v 1.1 2003/08/14 21:50:43 finson Exp $

function varargout = normalgui(varargin)
% NORMALGUI M-file for normalgui.fig
%      NORMALGUI, by itself, creates a new NORMALGUI or raises the existing
%      singleton*.
%
%      H = NORMALGUI returns the handle to a new NORMALGUI or the handle to
%      the existing singleton*.
%
%      NORMALGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in NORMALGUI.M with the given input arguments.
%
%      NORMALGUI('Property','Value',...) creates a new NORMALGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before normalgui_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to normalgui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help normalgui

% Last Modified by GUIDE v2.5 14-Aug-2003 13:02:32

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @normalgui_OpeningFcn, ...
                   'gui_OutputFcn',  @normalgui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --------------------------------------------------------------------
% --- Executes just before normalgui is made visible.
function normalgui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to normalgui (see VARARGIN)

% Choose default command line output for normalgui
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% This sets up the initial plot - only do when we are invisible
% so window can get raised using normalgui.
if strcmp(get(hObject,'Visible'),'off')
	handles.axis_x = [-5 0; 5 0];
	handles.axis_y = [0 -5; 0 5]; 
    guidata(hObject, handles);
	calculate_curve(hObject)
	draw_figure(hObject)
end

% --------------------------------------------------------------------
% UIWAIT makes normalgui wait for user response (see UIRESUME)
% uiwait(handles.figure1);

% --------------------------------------------------------------------
% --- Outputs from this function are returned to the command line.
function varargout = normalgui_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --------------------------------------------------------------------
function FileMenu_Callback(hObject, eventdata, handles)
% hObject    handle to FileMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function OpenMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to OpenMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
file = uigetfile('*.fig');
if ~isequal(file, 0)
    open(file);
end

% --------------------------------------------------------------------
function PrintMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to PrintMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
printdlg(handles.figure1)

% --------------------------------------------------------------------
function CloseMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to CloseMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
selection = questdlg(['Close ' get(handles.figure1,'Name') '?'],...
                     ['Close ' get(handles.figure1,'Name') '...'],...
                     'Yes','No','Yes');
if strcmp(selection,'No')
    return;
end

delete(handles.figure1)

%------------------------------------------------------
% --- Executes during object creation, after setting all properties.
function face_count_CreateFcn(hObject, eventdata, handles)
% hObject    handle to face_count (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

%------------------------------------------------------
% --- Executes on selection change in face_count.
function face_count_Callback(hObject, eventdata, handles)
calculate_curve(hObject)
draw_figure(hObject)
return

%------------------------------------------------------
% --- Executes on button press in show_curve.
function show_curve_Callback(hObject, eventdata, handles)
draw_figure(hObject)
return

%------------------------------------------------------
% --- Executes on button press in show_faces.
function show_faces_Callback(hObject, eventdata, handles)
draw_figure(hObject)
return

%------------------------------------------------------
% --- Executes on button press in show_curve_normals.
function show_curve_normals_Callback(hObject, eventdata, handles)
draw_figure(hObject)
return

%------------------------------------------------------
% --- Executes on button press in show_face_normals.
function show_face_normals_Callback(hObject, eventdata, handles)
draw_figure(hObject)
return

%------------------------------------------------------
% --- Executes on button press in show_vertex_normals.
function show_vertex_normals_Callback(hObject, eventdata, handles)
draw_figure(hObject)
return

%------------------------------------------------------
% --- Executes on button press in show_interpolated.
function show_interpolated_Callback(hObject, eventdata, handles)
draw_figure(hObject)
return

%------------------------------------------------------
% redraw the figure
% fig       figure handle (or figure child component handle)
function draw_figure(fig)
handles = guidata(fig);
cla
plot(handles.axis_x,handles.axis_y,'.','MarkerEdgeColor','none');
axis equal
axis manual
set(handles.axes1,'XTick',[])
set(handles.axes1,'YTick',[])
hold on

state = get(handles.show_curve,'Value');
if state == 1
    plot(handles.curve_x,handles.curve_y,'-b')
end

state = get(handles.show_faces,'Value');
if state == 1
    plot(handles.face_x,handles.face_y,'-r')
end

state = get(handles.show_curve_normals,'Value');
if state == 1
    plot(handles.curve_normal_x,handles.curve_normal_y,'-b')
end

state = get(handles.show_vertex_normals,'Value');
if state == 1
    plot(handles.vertex_normal_x,handles.vertex_normal_y,'-k')
end

state = get(handles.show_face_normals,'Value');
if state == 1
    plot(handles.face_normal_x,handles.face_normal_y,'-r')
end

state = get(handles.show_interpolated,'Value');
if state == 1
    plot(handles.interpolated_normal_x, handles.interpolated_normal_y,'-k')
end
return

%------------------------------------------------------
% calculate the various (x,y) lists
% fig       figure handle (or figure child component handle)
function calculate_curve(fig)
handles = guidata(fig);

% the curve itself

t = [0:.01:1];
amp = 3;
phase = 2*pi;
handles.curve_x = amp*cos(t'*phase);
handles.curve_y = amp*sin(t'*phase);

% the curve normals

tStep = 1/32;
tNormal = [0:tStep:1-tStep];
x = amp*cos(tNormal*phase);
y = amp*sin(tNormal*phase);
dxdt = -(amp*-sin(tNormal*phase)*phase);
dydt = -(amp*cos(tNormal*phase)*phase);
magnitude = abs(complex(dxdt,dydt));

handles.curve_normal_x_direction = -dydt ./ magnitude;
handles.curve_normal_y_direction = dxdt ./ magnitude;

handles.curve_normal_x = [x; x + handles.curve_normal_x_direction];
handles.curve_normal_y = [y; y + handles.curve_normal_y_direction];

% the faces

val = get(handles.face_count,'Value');
string_list = get(handles.face_count,'String');
selected_string = string_list{val}; % convert from cell array to string
nFaces = str2num(selected_string);

t = [0:1/nFaces:1];
handles.face_x = amp*cos(t'*phase);
handles.face_y = amp*sin(t'*phase);

% the face normals

x = handles.face_x';
y = handles.face_y';
dxdt = -(x(2:length(x))-x(1:length(x)-1));
dydt = -(y(2:length(y))-y(1:length(y)-1));
magnitude = abs(complex(dxdt,dydt));

handles.face_normal_x = ...
    [x(1:length(x)-1) x(2:length(x));  ...
    x(1:length(x)-1)+(-dydt ./ magnitude) x(2:length(x))+(-dydt ./ magnitude)];
handles.face_normal_y =  ...
    [y(1:length(y)-1) y(2:length(y));  ...
    y(1:length(y)-1)+(dxdt ./ magnitude) y(2:length(y))+(dxdt ./ magnitude)];

% the vertex normals

tVertex = [0:1/nFaces:1];
x = amp*cos(tVertex*phase);
y = amp*sin(tVertex*phase);
dxdt = -(amp*-sin(tVertex*phase)*phase);
dydt = -(amp*cos(tVertex*phase)*phase);
magnitude = abs(complex(dxdt,dydt));

handles.vertex_normal_x_direction = -dydt ./ magnitude;
handles.vertex_normal_y_direction = dxdt ./ magnitude;

handles.vertex_normal_x = [x; x + handles.vertex_normal_x_direction];
handles.vertex_normal_y = [y; y + handles.vertex_normal_y_direction];

% the interpolated normals

xD = interp1(tVertex,handles.vertex_normal_x_direction,tNormal);
yD = interp1(tVertex,handles.vertex_normal_y_direction,tNormal);
magnitude = abs(complex(xD,yD));
xD = xD ./ magnitude;
yD = yD ./ magnitude;

handles.interpolated_normal_x(1,:) = interp1(tVertex,handles.vertex_normal_x(1,:),tNormal);
handles.interpolated_normal_x(2,:) = handles.interpolated_normal_x(1,:) + xD;

handles.interpolated_normal_y(1,:) = interp1(tVertex,handles.vertex_normal_y(1,:),tNormal);
handles.interpolated_normal_y(2,:) = handles.interpolated_normal_y(1,:) + yD;

% all done

guidata(fig, handles);
